var documenterSearchIndex = {"docs":
[{"location":"index.html","page":"Home","title":"Home","text":"CurrentModule = KNearestCenters","category":"page"},{"location":"index.html#KNearestCenters","page":"Home","title":"KNearestCenters","text":"","category":"section"},{"location":"index.html","page":"Home","title":"Home","text":"","category":"page"},{"location":"index.html","page":"Home","title":"Home","text":"Modules = [KNearestCenters]","category":"page"},{"location":"index.html#KNearestCenters.Knc","page":"Home","title":"KNearestCenters.Knc","text":"A simple nearest centroid classifier with support for kernel functions\n\n\n\n\n\n","category":"type"},{"location":"index.html#KNearestCenters.Knc-Tuple{KncConfig,Any,CategoricalArrays.CategoricalArray}","page":"Home","title":"KNearestCenters.Knc","text":"Knc(config::KncConfig, X, y::CategoricalArray; verbose=true)\nKnc(config::KncConfig,\n    input_clusters::ClusteringData,\n    train_X::AbstractVector,\n    train_y::CategoricalArray;\n    verbose=false\n)\n\nCreates a Knc classifier using the given configuration and data.\n\n\n\n\n\n","category":"method"},{"location":"index.html#KNearestCenters.KncConfigSpace-Tuple{}","page":"Home","title":"KNearestCenters.KncConfigSpace","text":"KncConfigSpace(;\n    kernel::Array=[k_(d_()) for k_ in [DirectKernel, ReluKernel],\n                                d_ in [L2Distance, CosineDistance]],                         \n    centerselection::AbstractVector=[CentroidSelection(), RandomCenterSelection(), MedoidSelection(), KnnCentroidSelection()],\n    k::AbstractVector=[1],\n    maxiters::AbstractVector=[1, 3, 10],\n    recall::AbstractVector=[1.0],\n    ncenters::AbstractVector=[0, 10],\n    initial_clusters::AbstractVector=[:fft, :dnet, :rand],\n    split_entropy::AbstractVector=[0.3, 0.6, 0.9],\n    minimum_elements_per_region::AbstractVector=[1, 3, 5]\n)\n\nCreates a configuration space for KncConfig\n\n\n\n\n\n","category":"method"},{"location":"index.html#Distances.evaluate-Tuple{CauchyKernel,Any,Any,AbstractFloat}","page":"Home","title":"Distances.evaluate","text":"evaluate(kernel::CauchyKernel, a, b, σ::AbstractFloat)::Float64\n\nCreates a Cauchy kernel with the given distance function\n\n\n\n\n\n","category":"method"},{"location":"index.html#Distances.evaluate-Tuple{DirectKernel,Any,Any,AbstractFloat}","page":"Home","title":"Distances.evaluate","text":"evaluate(kernel::DirectKernel, a, b, σ::AbstractFloat)::Float64\n\nCreates a Direct kernel with the given distance function\n\n\n\n\n\n","category":"method"},{"location":"index.html#Distances.evaluate-Tuple{GaussianKernel,Any,Any,AbstractFloat}","page":"Home","title":"Distances.evaluate","text":"evaluate(kernel::GaussianKernel, a, b, σ::AbstractFloat)::Float64\n\nCreates a Gaussian kernel with the given distance function\n\n\n\n\n\n","category":"method"},{"location":"index.html#Distances.evaluate-Tuple{LaplacianKernel,Any,Any,AbstractFloat}","page":"Home","title":"Distances.evaluate","text":"evaluate(kernel::LaplacianKernel, a, b, σ::AbstractFloat)::Float64\n\nCreates a Laplacian kernel with the given distance function\n\n\n\n\n\n","category":"method"},{"location":"index.html#Distances.evaluate-Tuple{ReluKernel,Any,Any,AbstractFloat}","page":"Home","title":"Distances.evaluate","text":"evaluate(kernel::ReluKernel, a, b, σ::AbstractFloat)::Float64\n\nCreates a Relu kernel with the given distance function\n\n\n\n\n\n","category":"method"},{"location":"index.html#Distances.evaluate-Tuple{SigmoidKernel,Any,Any,AbstractFloat}","page":"Home","title":"Distances.evaluate","text":"evaluate(kernel::SigmoidKernel, a, b, σ::AbstractFloat)::Float64\n\nCreates a Sigmoid kernel with the given distance function\n\n\n\n\n\n","category":"method"},{"location":"index.html#Distances.evaluate-Tuple{TanhKernel,Any,Any,AbstractFloat}","page":"Home","title":"Distances.evaluate","text":"evaluate(kernel::TanhKernel, a, b, σ::AbstractFloat)::Float64\n\nCreates a Tanh kernel with the given distance function\n\n\n\n\n\n","category":"method"},{"location":"index.html#KNearestCenters.accuracy_score-Union{Tuple{T1}, Tuple{T2}, Tuple{AbstractArray{T1,1},AbstractArray{T2,1}}} where T1<:Integer where T2<:Integer","page":"Home","title":"KNearestCenters.accuracy_score","text":"accuracy_score(gold::T, predicted::T) where T\n\nComputes the accuracy score between the gold and the predicted sets\n\n\n\n\n\n","category":"method"},{"location":"index.html#KNearestCenters.change_criterion","page":"Home","title":"KNearestCenters.change_criterion","text":"change_criterion(tol=0.001, window=3)\n\nCreates a fuction that stops the process whenever the maximum distance converges (averaging window far items). The tol parameter defines the tolerance range.\n\n\n\n\n\n","category":"function"},{"location":"index.html#KNearestCenters.classification_scores-Union{Tuple{T1}, Tuple{T2}, Tuple{AbstractArray{T1,1},AbstractArray{T2,1}}} where T1<:Integer where T2<:Integer","page":"Home","title":"KNearestCenters.classification_scores","text":"classification_scores(gold, predicted)\n\nComputes several scores for the given gold-standard and predictions, namely:  precision, recall, and f1 scores, for global and per-class granularity\n\n\n\n\n\n","category":"method"},{"location":"index.html#KNearestCenters.combine_configurations-Union{Tuple{T}, Tuple{Type{T},Any}} where T<:KncConfig","page":"Home","title":"KNearestCenters.combine_configurations","text":"combine_configurations(::Type{T}, config_list) where {T<:KncConfig}\n\nCreates a new configuration combining the given configurations\n\n\n\n\n\n","category":"method"},{"location":"index.html#KNearestCenters.epsilon_criterion-Tuple{Any}","page":"Home","title":"KNearestCenters.epsilon_criterion","text":"epsilon_criterion(e)\n\nCreates a function that evaluates the stop criterion when the distance between far items achieves the given e\n\n\n\n\n\n","category":"method"},{"location":"index.html#KNearestCenters.f1_score-Tuple{Any,Any}","page":"Home","title":"KNearestCenters.f1_score","text":"f1_score(gold, predict; weight=:macro)::Float64\n\nIt computes the F1 score between the gold dataset and the list of predictions predict\n\nIt applies the desired weighting scheme for binary and multiclass problems\n\n:macro performs a uniform weigth to each class\n:weigthed the weight of each class is proportional to its population in gold\n:micro returns the global F1, without distinguishing among classes\n\n\n\n\n\n","category":"method"},{"location":"index.html#KNearestCenters.fun_criterion-Tuple{Any}","page":"Home","title":"KNearestCenters.fun_criterion","text":"fun_criterion(fun::Function)\n\nCreates a stop-criterion function that stops whenever the number of far items reaches lceil fun(database)rceil. Already defined examples:\n\n    sqrt_criterion() = fun_criterion(sqrt)\n    log2_criterion() = fun_criterion(log2)\n\n\n\n\n\n","category":"method"},{"location":"index.html#KNearestCenters.isqerror-Union{Tuple{F}, Tuple{AbstractArray{F,1},AbstractArray{F,1}}} where F<:AbstractFloat","page":"Home","title":"KNearestCenters.isqerror","text":"isqerror(X::AbstractVector{F}, Y::AbstractVector{F}) where {F <: AbstractFloat}\n\nNegative squared error (to be used for maximizing algorithms)\n\n\n\n\n\n","category":"method"},{"location":"index.html#KNearestCenters.mean_label-Tuple{Knc,SimilaritySearch.KnnResult}","page":"Home","title":"KNearestCenters.mean_label","text":"mean_label(nc::Knc, res::KnnResult)\n\nSummary function that computes the label as the mean of the k nearest labels (ordinal classification)\n\n\n\n\n\n","category":"method"},{"location":"index.html#KNearestCenters.most_frequent_label-Tuple{Knc,SimilaritySearch.KnnResult}","page":"Home","title":"KNearestCenters.most_frequent_label","text":"most_frequent_label(nc::Knc, res::KnnResult)\n\nSummary function that computes the label as the most frequent label among labels of the k nearest prototypes (categorical labels)\n\n\n\n\n\n","category":"method"},{"location":"index.html#KNearestCenters.pearson-Union{Tuple{F}, Tuple{AbstractArray{F,1},AbstractArray{F,1}}} where F<:AbstractFloat","page":"Home","title":"KNearestCenters.pearson","text":"pearson(X::AbstractVector{F}, Y::AbstractVector{F}) where {F <: AbstractFloat}\n\nPearson correlation score\n\n\n\n\n\n","category":"method"},{"location":"index.html#KNearestCenters.precision_recall-Union{Tuple{T1}, Tuple{T2}, Tuple{AbstractArray{T1,1},AbstractArray{T2,1}}} where T1<:Integer where T2<:Integer","page":"Home","title":"KNearestCenters.precision_recall","text":"precision_recall(gold::AbstractVector{T1}, predicted::AbstractVector{T2}) where {T1<:Integer} where {T2<:Integer\n\nComputes the global and per-class precision and recall values between the gold standard and the predicted set\n\n\n\n\n\n","category":"method"},{"location":"index.html#KNearestCenters.precision_score-Tuple{Any,Any}","page":"Home","title":"KNearestCenters.precision_score","text":"precision_score(gold, predict; weight=:macro)::Float64\n\nIt computes the precision between the gold dataset and the list of predictions predict\n\nIt applies the desired weighting scheme for binary and multiclass problems\n\n:macro performs a uniform weigth to each class\n:weigthed the weight of each class is proportional to its population in gold\n:micro returns the global precision, without distinguishing among classes\n\n\n\n\n\n","category":"method"},{"location":"index.html#KNearestCenters.random_configuration-Tuple{KncConfigSpace}","page":"Home","title":"KNearestCenters.random_configuration","text":"random_configuration(space::KncConfigSpace)\n\nCreates a random KncConfig instance based on the space definition.\n\n\n\n\n\n","category":"method"},{"location":"index.html#KNearestCenters.recall_score-Tuple{Any,Any}","page":"Home","title":"KNearestCenters.recall_score","text":"recall_score(gold, predict; weight=:macro)::Float64\n\nIt computes the recall between the gold dataset and the list of predictions predict\n\nIt applies the desired weighting scheme for binary and multiclass problems\n\n:macro performs a uniform weigth to each class\n:weigthed the weight of each class is proportional to its population in gold\n:micro returns the global recall, without distinguishing among classes\n\n\n\n\n\n","category":"method"},{"location":"index.html#KNearestCenters.salesman_criterion-Tuple{}","page":"Home","title":"KNearestCenters.salesman_criterion","text":"salesman_criterion()\n\nIt creates a function that explores the entire dataset making a full farthest first traversal approximation\n\n\n\n\n\n","category":"method"},{"location":"index.html#KNearestCenters.size_criterion-Tuple{Any}","page":"Home","title":"KNearestCenters.size_criterion","text":"size_criterion(maxsize)\n\nCreates a function that stops when the number of far items are equal or larger than the given maxsize\n\n\n\n\n\n","category":"method"},{"location":"index.html#KNearestCenters.softmax!-Tuple{AbstractArray{T,1} where T}","page":"Home","title":"KNearestCenters.softmax!","text":"softmax!(vec::AbstractVector)\n\nInline computation of the softmax function on the input vector\n\n\n\n\n\n","category":"method"},{"location":"index.html#KNearestCenters.spearman-Union{Tuple{F}, Tuple{AbstractArray{F,1},AbstractArray{F,1}}} where F<:AbstractFloat","page":"Home","title":"KNearestCenters.spearman","text":"spearman(X::AbstractVector{F}, Y::AbstractVector{F}) where {F <: AbstractFloat}\n\nSpearman rank correleation score\n\n\n\n\n\n","category":"method"},{"location":"index.html#KNearestCenters.transform","page":"Home","title":"KNearestCenters.transform","text":"transform(nc::Knc, kernel::Function, X, normalize!::Function=softmax!)\n\nMaps a collection of objects to the vector space defined by each center in nc; the kernel function is used measure the similarity between each u in X and each center in nc. The normalization function is applied to each vector (normalization methods needing to know the attribute's distribution can be applied on the output of transform)\n\n\n\n\n\n","category":"function"},{"location":"index.html#StatsBase.predict-Tuple{Knc,Any,SimilaritySearch.KnnResult}","page":"Home","title":"StatsBase.predict","text":"predict(nc::Knc, x, res::KnnResult)\npredict(nc::Knc, x)\n\nPredicts the class of x using the label of the k nearest centers under the kernel function.\n\n\n\n\n\n","category":"method"}]
}
